sandbox/demo/urls.py
"""
Urls for "crispy form foundation" demo
"""
from django.urls import re_path
from django.views.generic.base import TemplateView

from .views import (
    FormByFieldsetView, FormByTabView, FormByAccordionView, StaticPage
)


app_name = 'demo'

urlpatterns = [
    re_path(r'^foundation-(?P<foundation_version>\d+)/$',
        FormByFieldsetView.as_view(),
        name='crispy-demo-form-fieldsets'),
    re_path(r'^foundation-(?P<foundation_version>\d+)/fieldsets/$',
        FormByFieldsetView.as_view(),
        name='crispy-demo-form-fieldsets'),
    re_path(r'^foundation-(?P<foundation_version>\d+)/tabs/$',
        FormByTabView.as_view(),
        name='crispy-demo-form-tabs'),
    re_path(r'^foundation-(?P<foundation_version>\d+)/accordions/$',
        FormByAccordionView.as_view(),
        name='crispy-demo-form-accordions'),
    re_path(r'^foundation-(?P<foundation_version>\d+)/success/$',
        StaticPage.as_view(),
        name='crispy-demo-success'),
]

sandbox/urls.py
"""
Sandbox URL Configuration
"""
from django.urls import include, re_path
from django.contrib import admin

from django.views.generic.base import TemplateView


urlpatterns = [
    # Dummy homepage just for simple ping view
    re_path(r'^$', TemplateView.as_view(
        template_name="homepage.html"
    ), name='home'),

     re_path(r'^crispy-forms/',
         include('sandbox.demo.urls', namespace='demo')),
]

try:
    import debug_toolbar
    urlpatterns += [
        re_path(r'^__debug__/', include(debug_toolbar.urls)),
    ]
except ImportError:
    pass

sandbox/demo/forms.py
from django import forms
from django.utils.translation import gettext_lazy as _

from crispy_forms.helper import FormHelper
from crispy_forms_foundation.layout import (
    Layout, Fieldset, TabItem, TabHolder, AccordionHolder, AccordionItem
)

from .crispies import (
    part_1_crispies, part_2_crispies, part_3_crispies, part_4_crispies,
    buttons_crispies
)


SELECT_INPUT_CHOICES = [('item-{0}'.format(i), 'Option item {0}'.format(i))
                        for i in range(1, 6)]
RADIO_INPUT_CHOICES = [('item-{0}'.format(i), 'Radio item {0}'.format(i))
                       for i in range(1, 4)]


class BaseForm(forms.Form):
    """
    Base form with inputs
    """
    full_input = forms.CharField(label=_('Full width input'), widget=forms.TextInput(attrs={'required':''}), required=True, help_text="This is a sample field help text.")
    column_input_1 = forms.CharField(label=_('Column input 1'), required=False)
    column_input_2 = forms.CharField(label=_('Column input 2'), required=True)
    column_input_3 = forms.CharField(label=_('Column input 3'), required=False)
    textarea_input = forms.CharField(label=_('Textarea'), widget=forms.Textarea(attrs={'rows':5, 'required':''}), required=True)
    select_input = forms.ChoiceField(label=_('Select input'), choices=SELECT_INPUT_CHOICES, required=True)
    radio_input = forms.ChoiceField(label=_('Radio inputs'), choices=RADIO_INPUT_CHOICES, widget=forms.RadioSelect, required=False)
    checkbox_input = forms.BooleanField(label=_('Checkbox input'), required=False)
    checkbox_switch_input_1 = forms.BooleanField(label=_('Checkbox switch'), required=False)
    checkbox_switch_input_2 = forms.BooleanField(label=_('Checkbox inline switch'), required=False)
    inlinefield_input = forms.CharField(label=_('Inline field'), required=False)
    inlinejustifiedfield_input = forms.CharField(label=_('Inline justified field'), required=False)

    def clean(self):
        cleaned_data = super(BaseForm, self).clean()
        checkbox_input = cleaned_data.get("checkbox_input")

        if checkbox_input and checkbox_input == True:
            raise forms.ValidationError([
                'This is a global error',
                'This is another global error',
                'Uncheck the "Checkbox input" to ignore these errors']
            )

        # Always return the full collection of cleaned data.
        return cleaned_data

    def save(self, commit=True):
        # Do nothing
        return


class FormCrispyHelperMixin(object):
    """
    Form that define an empty helper and able to switch template pack
    """
    def __init__(self, *args, **kwargs):
        self.helper = FormHelper()
        self.helper.template_pack = kwargs.pop('pack')

        super(FormCrispyHelperMixin, self).__init__(*args, **kwargs)


class FormByFieldsetsForm(FormCrispyHelperMixin, BaseForm):
    def __init__(self, *args, **kwargs):
        super(FormByFieldsetsForm, self).__init__(*args, **kwargs)

        self.helper.attrs = {'data_abide': '', 'novalidate': ''}
        self.helper.form_action = '.'

        part1 = [_('Part 1')]+part_1_crispies(pack=self.helper.template_pack)
        part2 = [_('Part 2')]+part_2_crispies(pack=self.helper.template_pack)
        part3 = [_('Part 3')]+part_3_crispies(pack=self.helper.template_pack)
        part4 = [_('Part 4')]+part_4_crispies(pack=self.helper.template_pack)

        self.helper.layout = Layout(
            Fieldset(*part1),
            Fieldset(*part2),
            Fieldset(*part3),
            Fieldset(*part4),
            *buttons_crispies(pack=self.helper.template_pack)
        )


class FormByTabsForm(FormCrispyHelperMixin, BaseForm):
    def __init__(self, *args, **kwargs):
        super(FormByTabsForm, self).__init__(*args, **kwargs)

        self.helper.attrs = {'data_abide': ''}
        self.helper.form_action = '.'

        part1 = [_('Part 1')]+part_1_crispies(pack=self.helper.template_pack)
        part2 = [_('Part 2')]+part_2_crispies(pack=self.helper.template_pack)
        part3 = [_('Part 3')]+part_3_crispies(pack=self.helper.template_pack)
        part4 = [_('Part 4')]+part_4_crispies(pack=self.helper.template_pack)

        self.helper.layout = Layout(
            TabHolder(
                TabItem(*part1),
                TabItem(*part2),
                TabItem(*part3),
                TabItem(*part4),
            ),
            *buttons_crispies(pack=self.helper.template_pack)
        )


class FormByAccordionsForm(FormCrispyHelperMixin, BaseForm):
    def __init__(self, *args, **kwargs):
        super(FormByAccordionsForm, self).__init__(*args, **kwargs)

        self.helper.attrs = {'data_abide': ''}
        self.helper.form_action = '.'

        part1 = [_('Part 1')]+part_1_crispies(pack=self.helper.template_pack)
        part2 = [_('Part 2')]+part_2_crispies(pack=self.helper.template_pack)
        part3 = [_('Part 3')]+part_3_crispies(pack=self.helper.template_pack)
        part4 = [_('Part 4')]+part_4_crispies(pack=self.helper.template_pack)

        self.helper.layout = Layout(
            AccordionHolder(
                AccordionItem(*part1),
                AccordionItem(*part2),
                AccordionItem(*part3),
                AccordionItem(*part4),
            ),
            *buttons_crispies(pack=self.helper.template_pack)
        )

sandbox/demo/views.py
"""
Views
"""
from django import __version__ as django_version
from django import template
from django.views.generic.edit import FormView
from django.views.generic.base import TemplateView
from django.urls import reverse

from crispy_forms_foundation import __version__ as crispy_foundation_version
from crispy_forms import __version__ as crispy_version
from .forms import FormByFieldsetsForm, FormByTabsForm, FormByAccordionsForm


class CrispyFoundationMixin(object):
    def get_versions(self):
        return {
            "foundation_version": self.kwargs.get('foundation_version'),
            "django": django_version,
            "django_crispy_forms": crispy_version,
            "crispy_forms_foundation": crispy_foundation_version,
        }

    def get_context_data(self, **kwargs):
        context = super(CrispyFoundationMixin, self).get_context_data(**kwargs)
        context.update(self.get_versions())
        return context


class FormContainersMixin(object):
    def get_success_url(self):
        return reverse('demo:crispy-demo-success', kwargs={
            'foundation_version': int(self.kwargs.get('foundation_version'))
        })

    def get_form_kwargs(self):
        """
        Pass template pack argument
        """
        kwargs = super(FormContainersMixin, self).get_form_kwargs()
        kwargs.update({
            'pack': "foundation-{}".format(self.kwargs.get('foundation_version'))
        })
        return kwargs


class FormByFieldsetView(FormContainersMixin, CrispyFoundationMixin, FormView):
    template_name = 'crispy_demo/fieldsets.html'
    form_class = FormByFieldsetsForm


class FormByTabView(FormContainersMixin, CrispyFoundationMixin, FormView):
    template_name = 'crispy_demo/tabs.html'
    form_class = FormByTabsForm


class FormByAccordionView(FormContainersMixin, CrispyFoundationMixin, FormView):
    template_name = 'crispy_demo/accordions.html'
    form_class = FormByAccordionsForm


class StaticPage(FormContainersMixin, CrispyFoundationMixin, TemplateView):
    template_name = 'crispy_demo/success.html'

sandbox/demo/templates/crispy_demo/accordions.html
{% extends "crispy_demo/base_forms.html" %}
{% load static %}
{% block crispy_demo_menu_accordions_item %}{% endblock %}

sandbox/demo/templates/crispy_demo/base_forms.html
{% extends "skeleton.html" %}
{% load i18n crispy_forms_tags %}

{% block header_assets %}
    {% include 'crispy_demo/assets/foundation6_header_assets.html' %}
{% endblock header_assets %}

{% block base_content %}<div class="row">
    <div class="small-12 columns">
        <a href="{% url 'home' %}" class="button tiny radius secondary">&lt; Index</a>
        <h2>{% blocktrans with version=foundation_version %}Crispy forms Foundation {{ version }} sample{% endblocktrans %}</h2>
        {% with packages_versions=view.get_versions %}
        <p class="text-right">
            <span class="label">django=={{ packages_versions.django }}</span>
            <span class="label">django-crispy-forms=={{ packages_versions.django_crispy_forms }}</span>
            <span class="label">crispy-forms-foundation=={{ packages_versions.crispy_forms_foundation }}</span>
        </p>
        {% endwith %}
        <hr>

        <div class="stacked-for-small round button-group">
            <a href="{% url 'demo:crispy-demo-form-fieldsets' foundation_version=foundation_version %}" class="button{% block crispy_demo_menu_fieldsets_item %} secondary{% endblock %}">Form by fieldsets</a>
            <a href="{% url 'demo:crispy-demo-form-accordions' foundation_version=foundation_version %}" class="button{% block crispy_demo_menu_accordions_item %} secondary{% endblock %}">Form by accordions</a>
            <a href="{% url 'demo:crispy-demo-form-tabs' foundation_version=foundation_version %}" class="button{% block crispy_demo_menu_tabs_item %} secondary{% endblock %}">Form by tabs</a>
        </div>


        {% crispy form %}
    </div>
</div>{% endblock %}

{% block footer_assets %}
    {% include 'crispy_demo/assets/foundation6_footer_assets.html' %}
{% endblock footer_assets %}

sandbox/demo/templates/crispy_demo/fieldsets.html
{% extends "crispy_demo/base_forms.html" %}
{% block crispy_demo_menu_fieldsets_item %}{% endblock %}

sandbox/demo/templates/crispy_demo/index.html
{% extends "skeleton.html" %}
{% load i18n %}

{% block menu_item_contact %} class="active"{% endblock %}

{% block base_content %}<div class="row">
    <h2>Demo index</h2>

    <hr>
    <div class="large-6 columns text-center">
        <p><a href="{% url 'demo:crispy-demo-form-fieldsets' foundation_version=foundation_version %}" class="button large">Form by fieldsets</a></p>
        <p><a href="{% url 'demo:crispy-demo-form-accordions' foundation_version=foundation_version %}" class="button large">Form by accordions</a></p>
        <p><a href="{% url 'demo:crispy-demo-form-tabs' foundation_version=foundation_version %}" class="button large">Form by tabs</a></p>
    </div>
</div>{% endblock %}

sandbox/demo/templates/crispy_demo/success.html
{% extends "skeleton.html" %}
{% load i18n %}

{% block base_content %}<div class="row">
    <div class="small-12 columns">
        <h2>{% trans 'Success' %}</h2>

        <p>{% trans 'Great job !' %}</p>
    </div>
</div>{% endblock %}

sandbox/demo/templates/crispy_demo/tabs.html
{% extends "crispy_demo/base_forms.html" %}
{% load static %}
{% block crispy_demo_menu_tabs_item %}{% endblock %}